=== debian/changelog ===
fastnetmon (1.2.3-3build3) lunar; urgency=medium

  * Rebuild against latest icu

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 05 Feb 2023 12:58:39 -0500

fastnetmon (1.2.3-3build2) lunar; urgency=medium

  * No-change rebuild against libcapnp-0.9.2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 04 Feb 2023 00:37:38 +0000

fastnetmon (1.2.3-3build1) lunar; urgency=medium

  * Rebuild against new libgrpc29.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 04 Jan 2023 12:04:21 +0100

fastnetmon (1.2.3-3) unstable; urgency=medium

  * Add patch to fix a FTBFS with gRPC version 1.51.
    Closes: #1025490
  * Bump Standards-Version to 4.6.2.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 27 Dec 2022 13:09:22 +0100

fastnetmon (1.2.3-2) unstable; urgency=medium

  * Add upstream patches 01-deprecated-function and 02-new-libbpf-interface to
    support libbpf 1.0.1.
    Closes: #1023555

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 09 Nov 2022 10:44:07 +0100

fastnetmon (1.2.3-1) unstable; urgency=medium

  * New upstream release.
    - Drop dependency on libjson-c-dev.
    - Add new dependencies on libbpf-dev and libelf-dev.
  * Adjust debian/watch to work again with GitHub.

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 21 Oct 2022 10:25:06 +0200

fastnetmon (1.2.2-2) unstable; urgency=medium

  * Adjust lintian override.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 14 Sep 2022 14:50:56 +0200
