=== debian/changelog ===
fastnetmon (1.2.4-2+deb12u1) bookworm-security; urgency=medium

  [ Moritz Mühlenhoff ]
  * Fixes CVE-2024-56073: Zero-length templates for Netflow v9 allow remote
    attackers to cause a denial of service (divide-by-zero error and
    application crash).
    Closes: #1090387
  * Fixes CVE-2024-56072: The sFlow v5 plugin allows remote attackers to cause
    a denial of service (application crash) via a crafted packet that
    specifies many sFlow samples.
    Closes: #1090388

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 23 Dec 2024 10:30:10 +0100

fastnetmon (1.2.4-2) unstable; urgency=medium

  * Add upstream patches 03-gobgp-3.12 and 04-gobgp-bindings to support goBGP
    version 3.10 and 3.12.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 14 Mar 2023 15:23:10 +0100

fastnetmon (1.2.4-1) unstable; urgency=medium

  * New upstream release.
    - Drop merged patch 01-deprecated-function.
    - Drop merged patch 02-new-libbpf-interface.
    - Add upstream patches 01-mutex and 02-boost to address a FTBFS.
  * Update debian/copyright years.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 09 Mar 2023 16:57:28 +0100
