## fastnetmon 1.2.5

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,12 @@
-# It's version of cmake in our oldest supported distro CentOS 7: https://repology.org/project/cmake/versions
-cmake_minimum_required (VERSION 2.8.12)
+# We upgraded it to support https://cmake.org/cmake/help/latest/policy/CMP0077.html
+cmake_minimum_required (VERSION 3.13)
 
 set(FASTNETMON_LIBRARIES_GLOBAL_PATH "/opt/fastnetmon-community/libraries")
+
+# We need this options for generating compile_commands.json file
+# It's required for clang static analyzer and autocompletion tools based on clang
+# PVS uses it too
+set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 
 project(FastNetMon)
 
@@ -15,10 +20,10 @@
 
 set (FASTNETMON_VERSION_MAJOR 1)
 set (FASTNETMON_VERSION_MINOR 2)
-set (FASTNETMON_VERSION_PATCH 4)
+set (FASTNETMON_VERSION_PATCH 5)
 
 set(HIREDIS_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/hiredis_0_14")
-set(LOG4CPP_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/log4cpp_1_1_3")
+set(LOG4CPP_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/log4cpp_1_1_4")
 # set(LIBPCAP_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/pcap_1.7.4")
 set(MONGO_C_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/mongo_c_driver_1_23_0")
 set(CAPNP_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/capnproto_0_8_0")
@@ -34,11 +39,25 @@
 set(LIB_RDKAFKA_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/rdkafka_1_7_0")
 set(GTEST_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/gtest_1_13_0")
 
+# On Windows we need to build libgcc and libstdc++ statically to avoid need to carry dlls with us
+if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
+  set(CMAKE_CXX_STANDARD_LIBRARIES "-static-libgcc -static-libstdc++ ${CMAKE_CXX_STANDARD_LIBRARIES}")
+endif()
+
+# We need this to avoid dependency on libwinpthread-1.dll
+# Details: https://cmake.org/pipermail/cmake/2019-June/069611.html
+if (MINGW)
+  set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-Bstatic,--whole-archive -lwinpthread -Wl,--no-whole-archive")
+endif()
+
 set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} --std=c++2a")
 set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} --std=c++2a")
 
 # With this flag we can enable GoBGP build via console: cmake .. -DENABLE_GOBGP_SUPPORT=ON
 option(ENABLE_GOBGP_SUPPORT "Enable GoBGP support build" ON)
+
+# It can be disabled this way: cmake .. -DENABLE_PCAP_SUPPORT=OFF
+option(ENABLE_PCAP_SUPPORT "Enable PCAP support" ON)
 
 # On some platforms like Fedora we need to explicitly link with libabseil / libabsl.
 # We do not use it directly but gRPC uses it for libgpr and we need to link with absl explicitly to avoid linker errors like this:
@@ -247,52 +266,15 @@
     message(FATAL_ERROR "Can't find capnp compiler")
 endif()
 
+# We need to explicitly provide PATH for capnp to allow it to find capnpc-c++ 
+SET(CAPNP_ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}" "PATH=$ENV{PATH}:${CAPNP_CUSTOM_INSTALL_PATH}/bin")
+
+# We cannot pass environment variables before tool call on Windows and we actually do need it
+if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
+  SET(CAPNP_ENVIRONMENT "")
+endif()
 
 # Generate capnp bindings
 ADD_CUSTOM_COMMAND(
     OUTPUT ${PROJECT_SOURCE_DIR}/simple_packet_capnp/simple_packet.capnp.c++
     DEPENDS ${PROJECT_SOURCE_DIR}/simple_packet_capnp/simple_packet.capnp
-    COMMAND "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}" "PATH=$ENV{PATH}:${CAPNP_CUSTOM_INSTALL_PATH}/bin" ${CAPNP_BINARY} compile --output c++:${PROJECT_SOURCE_DIR}/simple_packet_capnp --src-prefix=${PROJECT_SOURCE_DIR}/simple_packet_capnp ${PROJECT_SOURCE_DIR}/simple_packet_capnp/simple_packet.capnp
-    COMMENT "Build Cap'n'Proto binding for C++"
-)
-
-add_library(simple_packet_capnp STATIC simple_packet_capnp/simple_packet.capnp.c++)
-
-endif()
-
-# Our LPM library
-add_library(patricia STATIC libpatricia/patricia.cpp)
-
-# Graphite metrics
-add_library(graphite_metrics STATIC metrics/graphite.cpp)
-target_link_libraries(fastnetmon graphite_metrics)
-
-# InfluxDB metrics
-add_library(influxdb_metrics STATIC metrics/influxdb.cpp)
-target_link_libraries(fastnetmon influxdb_metrics)
-
-add_library(fastnetmon_pcap_format STATIC fastnetmon_pcap_format.cpp)
-
-# Our tools library
-add_library(fast_library STATIC fast_library.cpp)
-
-# Our ipfix database library
-add_library(ipfix_rfc STATIC ipfix_rfc.cpp)
-
-add_library(bgp_protocol STATIC bgp_protocol.cpp)
-
-# Our logic library
-add_library(fastnetmon_logic STATIC fastnetmon_logic.cpp)
-
-CHECK_CXX_SOURCE_COMPILES("
-#include <linux/if_packet.h>
-int main() {
-    return TPACKET_V3;
-}
-" HAVE_TPACKET_V3)
-
-
-if (${HAVE_TPACKET_V3})
-    message(STATUS "Your system has support for AF_PACKET v3")
-    set (ENABLE_AFPACKET_SUPPORT ON)
-else()
