=== debian/changelog ===
fastnetmon (1.2.5-2) unstable; urgency=medium

  * Remove leftover files after the build process in dh_clean.
    Closes: #1044992
  * Adjust lintian overrides.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 23 Aug 2023 15:29:48 +0200

fastnetmon (1.2.5-1) unstable; urgency=medium

  * New upstream release.
    - Drop merged patch 01-mutex.
    - Drop merged patch 02-boost.
    - Drop merged patch 03-gobgp-3.12.
    - Drop merged patch 04-gobgp-bindings.
  * Use libncurses-dev build dependency.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 04 Jul 2023 15:38:39 +0200
