=== debian/control ===
--- 
+++ 
@@ -28,7 +28,7 @@
  liblog4cpp5-dev,
  libicu-dev,
  libmongoc-dev,
- libncurses5-dev,
+ libncurses-dev,
  libpcap-dev,
  pkg-config
 Homepage: https://fastnetmon.com/
