## fastnetmon 1.2.6

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,11 +20,11 @@
 
 set (FASTNETMON_VERSION_MAJOR 1)
 set (FASTNETMON_VERSION_MINOR 2)
-set (FASTNETMON_VERSION_PATCH 5)
+set (FASTNETMON_VERSION_PATCH 6)
 
 set(HIREDIS_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/hiredis_0_14")
 set(LOG4CPP_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/log4cpp_1_1_4")
-# set(LIBPCAP_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/pcap_1.7.4")
+set(LIBPCAP_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/pcap_1_10_4")
 set(MONGO_C_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/mongo_c_driver_1_23_0")
 set(CAPNP_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/capnproto_0_8_0")
 set(OPENSSL_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/openssl_1_1_1q")
@@ -39,6 +39,16 @@
 set(LIB_RDKAFKA_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/rdkafka_1_7_0")
 set(GTEST_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/gtest_1_13_0")
 
+# Enable time profiling for compilation phase
+# https://stackoverflow.com/questions/5962285/cmake-compilation-statistics-per-transation-unit
+# set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CMAKE_COMMAND} -E time")
+
+# -Wunused includes more warnings than -Wall
+# In order to get a warning about an unused function parameter, you must either specify -Wextra -Wunused (note that -Wall implies -Wunused), or separately specify -Wunused-parameter.
+# TODO: return -Wunused-parameter and address all warning later, I started it but did not finish as we have too many of them
+# catch-value is documented here: https://patchwork.ozlabs.org/project/gcc/patch/tkrat.8c7b4260a533be2f@netcologne.de/#1680619
+add_definitions("-Wreorder -Wunused -Wparentheses -Wimplicit-fallthrough -Wreturn-type -Wuninitialized -Winit-self -Wmaybe-uninitialized -Wcatch-value=3 -Wclass-memaccess")
+
 # On Windows we need to build libgcc and libstdc++ statically to avoid need to carry dlls with us
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
   set(CMAKE_CXX_STANDARD_LIBRARIES "-static-libgcc -static-libstdc++ ${CMAKE_CXX_STANDARD_LIBRARIES}")
@@ -50,8 +60,10 @@
   set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-Bstatic,--whole-archive -lwinpthread -Wl,--no-whole-archive")
 endif()
 
-set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} --std=c++2a")
-set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} --std=c++2a")
+# We use this approach instead of following:
+# set (CMAKE_CXX_STANDARD 20)
+# Because it allows us to specify intermediate releases and releases not yet supported by cmake
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++20")
 
 # With this flag we can enable GoBGP build via console: cmake .. -DENABLE_GOBGP_SUPPORT=ON
 option(ENABLE_GOBGP_SUPPORT "Enable GoBGP support build" ON)
@@ -126,11 +138,14 @@
 
     SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${LIB_CPP_KAFKA_INSTALL_PATH}/lib")
     SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${LIB_RDKAFKA_INSTALL_PATH}/lib")
+
+    SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${LIBPCAP_CUSTOM_INSTALL_PATH}/lib")
 else()
    # We do not need any RPATH alterations when we want to link with system libraries (i.e. upstream builds for Debian or RedHat family)
 endif()
 
-message(STATUS "C++ compilation flags: ${CMAKE_CXX_FLAGS_RELEASE}")
+message(STATUS "C++ default compilation flags: ${CMAKE_CXX_FLAGS}")
+message(STATUS "C++ release compilation flags: ${CMAKE_CXX_FLAGS_RELEASE}")
 message(STATUS "C++ debug compilation flags: ${CMAKE_CXX_FLAGS_DEBUG}")
 
 set(FASTNETMON_PROFILER OFF)
@@ -253,28 +268,3 @@
 # It's enabled by default but can be disabled using: 
 # cmake .. -DENABLE_CAPNP_SUPPORT=OFF
 option(ENABLE_CAPNP_SUPPORT "Enable Cap'N'Proto support build" ON)
-
-if (ENABLE_CAPNP_SUPPORT)
-
-message(STATUS "We will build Cap'N'Proto support")
-
-find_program(CAPNP_BINARY capnp PATHS "${CAPNP_CUSTOM_INSTALL_PATH}/bin" ${DISABLE_DEFAULT_PATH_SEARCH_VAR})
-
-if (CAPNP_BINARY)
-    message(STATUS "Found capnp compiler: ${CAPNP_BINARY}")
-else()
-    message(FATAL_ERROR "Can't find capnp compiler")
-endif()
-
-# We need to explicitly provide PATH for capnp to allow it to find capnpc-c++ 
-SET(CAPNP_ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}" "PATH=$ENV{PATH}:${CAPNP_CUSTOM_INSTALL_PATH}/bin")
-
-# We cannot pass environment variables before tool call on Windows and we actually do need it
-if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
-  SET(CAPNP_ENVIRONMENT "")
-endif()
-
-# Generate capnp bindings
-ADD_CUSTOM_COMMAND(
-    OUTPUT ${PROJECT_SOURCE_DIR}/simple_packet_capnp/simple_packet.capnp.c++
-    DEPENDS ${PROJECT_SOURCE_DIR}/simple_packet_capnp/simple_packet.capnp
