=== debian/changelog ===
fastnetmon (1.2.6-1build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:47:20 +1100

fastnetmon (1.2.6-1build3) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 17:54:20 +0000

fastnetmon (1.2.6-1build2) noble; urgency=medium

  * No-change rebuild against libhiredis1.1.0

 -- Dan Bungert <daniel.bungert@canonical.com>  Wed, 24 Jan 2024 08:28:35 -0700

fastnetmon (1.2.6-1build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:49:02 +0100

fastnetmon (1.2.6-1) unstable; urgency=medium

  * New upstream release.

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 27 Oct 2023 08:47:11 +0200
