=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: fastnetmon
-Maintainer: Patrick Matthäi <pmatthaei@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Patrick Matthäi <pmatthaei@debian.org>
 Section: net
 Priority: optional
 Standards-Version: 4.6.2
